clear final, clear runs, clear thresh, clear hidden, clear multidist, clear distdiv
clear dist, clear distmin, clear distmax, clear distrat, clear distset, clear ready,
clear Error, clear CONFIRM, clear Length, clear Reps, clear Persistent_Seedbank,
clear Initial_Pop_Vector, clear Extinction_Threshold, clear Disturbance_Return_Times,
clear distep, clear TotPop, clear AbovePop, clear distcounter, clear distimer, clear timer
clear CSV, clear extinctions, clear declines, clear minmat, clear maxmat
clear disinterval, clear phase, clear phasetimer, clear notaboves, clear matchose
clear terminate, clear ran, clear Result, clear Apparent_Extinctions, clear picker,
clear pseudophase, clear phasepicker, clear randvar
disp ('You must already have all of your matrices loaded as M1, M2, M3, and so on.')
disp ('In addition, you must have already run distassign.m or restored a saved state.')
% Section last modified June 7, 2001
ready=0;
space='	';
%Setup
while isequal (ready,0)
	clear hidden, clear ISV, clear thresh, clear runs, clear multidist, clear distset, clear distmin, clear distmax
	clear distdiv, clear distrat, clear Extinction_Threshold, clear Length, clear Reps, clear CONFIRM,
	clear Persistent_Seedbank, clear Initial_Pop_Vector, clear Disturbance_Return_Times
	hidden=input('Is the first stage a persistent seedbank (1=yes)? ');
	ISV=input('Enter initial stage vector: ');
	thresh=input('Enter extinction threshold: ');
	final=input('Enter duration of each run: ');
	phasedesvec(phases,3)=final;
	runs=input('How many runs for each simulation? ');
	multidist=input('Do you wish to run simulations for more than one disturbance frequency (1=yes)? ');
	distset=0;
	while isequal (distset,0)
		if isequal (multidist,1)
			distmin=input('Shortest disturbance return interval: ');
			distmax=input('Longest disturbance return interval: ');
			distdiv=input('How many disturbance return intervals do you wish to model? ');
			% So that there are distdiv intervals more than the shortest, rather than distdiv-1
			distdiv=distdiv-1;
			if isequal(distdiv,0)
				distdiv=1
			else
				distrat=((distmax-distmin)/distdiv);
			end
			if isequal(distrat,round(distrat))
				distset=1;
			else Error='Invalid, distmax minus distmin not divisble by number of intervals to model minus one'
		end
	else dist=input('Disturbance return interval (for no disturbances, enter any period > simulation length): ');
		distmax=dist;
		distmin=dist;
		distdiv=0;
		distrat=0;
		distset=1;
	end
end
%Confirm setup
Extinction_Threshold=num2str(thresh);
Length=num2str(final);
Reps=num2str(runs);
S1='Please verify you wish to use:';
S2=' time steps with an extinction threshold of';
CONFIRM=strcat(S1,space,Reps,' runs of',space,Length,S2,space,Extinction_Threshold)
if isequal(hidden,1)
	Persistent_Seedbank='Yes';
else Persistent_Seedbank='No';
end
Persistent_Seedbank
Initial_Pop_Vector=ISV
for distep = 0:distdiv
	Disturbance_Return_Times((distep+1),1)=distmin+distrat*distep;
end
Disturbance_Return_Times   
ready=input('If these are correct, enter "1", enter any other value to start over. ');
end
%Clean up old variables
clear multidist, clear dist, clear distset, clear Error, clear ready
clear CONFIRM, clear Length, clear Reps, clear Persistent_Seedbank,
clear Initial_Pop_Vector, clear Extinction_Threshold, clear Disturbance_Return_Times
%Run simulations
distcounter=1;
rand('state',sum(100*clock));
%For each disturbance interval
for distcounter=1:distdiv+1
	% Appropriate number of runs for each disturbance regime
	ran=0;
	notaboves=0;
	extinctions=0;
	declines=0;
	disinterval=distmin+(distcounter-1)*(distrat);
	for ran=1:runs
		CSV=ISV;
		terminate=0;		
		timer=1;
		phasetimer=1;
		phase=1;
		distimer=1;
		% Provide new seed each run				
		while isequal(terminate,0)
			%Projection for disturbance year			
			if isequal(phase,0)
				%Choose projection matrix - disturbance never interpolated
				picker=num2str(1+round(matsphase0*(rand(1))-.5));
				matchose=eval(strcat('M',picker));
				%Projection for non-disturbance year
			else %from if phase =0
				%Choose projection matrix - not interpolated								
				if isequal(phasedesvec(phase,4),0)
					if isequal(phase,1)
						minmat=matsphase0+1;
					else
						minmat=matsphase0+(sum(phasedesvec(1:phase-1,2)))+1;
					end
					maxmat=minmat+phasedesvec(phase,2);
					picker=num2str(minmat+round(phasedesvec(phase,2)*(rand(1))-.5));
					matchose=eval(strcat('M',picker));
				else %from if isequal(phasedesvec(phase,4),0) 
					%Choose pseudophase - linear interpolation
					if isequal(phasedesvec(phase,4),1)
						randvar=rand(1);
						phasepicker=-phasetimer/(phasedesvec(phase,3))+1;			
					else	
						%Choose pseudophase - exponential interpolation
						randvar=rand(1);
						phasepicker=e^(-3*phasetimer/(phasedesvec(phase,3)+1));
					end
					if randvar>phasepicker
						pseudophase=phase+1;
					else
						pseudophase=phase-1;
					end						
					%Choose projection matrix from pseudophase
					if isequal(pseudophase,1)
						minmat=matsphase0+1;
					else
						minmat=matsphase0+(sum(phasedesvec(1:pseudophase-1,2)))+1;
					end
					maxmat=matsphase0+sum(phasedesvec(1:pseudophase,2));
					picker=num2str(minmat+round(phasedesvec(pseudophase,2)*(rand(1))-.5));
					matchose=eval(strcat('M',picker));
				end % end of if isequal(phasedesvec(phase,4),0)
			end % if phase=0			
			%Project one step			
			CSV=matchose*CSV;            
			%Calculate population, end if extinct, update vector
			Totpop=sum(CSV(:,1));
			Abovepop=Totpop-CSV(1,1);
    	    if Totpop<=thresh
				CSV(:,1)=0;
				extinctions=extinctions+1;
				terminate=1;
			end
			%Update timers for passage of time, terminate run if time is up
			timer=timer+1;
			distimer=distimer+1;
			phasetimer=phasetimer+1;
			if timer>final
				terminate=1;
			end
			%Update from phase 1 on		
			if phase>0
				if phasetimer>phasedesvec(phase,3)
					phase=phase+1;
					phasetimer=1;
				end
			end
			%If phase 0 just ended, get ready to enter phase 1		
			if isequal (phase,0)
				phase=1;
				distimer=1;
			end
			%If it is time for another disturbance, set phase to zero		
			if isequal(distimer,disinterval)
				phase=0;
			end
		end %terminate while loop
		if Abovepop<=thresh
			notaboves=notaboves+1;
		end
	end %ran for loop
	%Report results when all runs for a given disturbance regime are complete
	S1='For a disturbance return interval of';
	S2=num2str(disinterval);
	S3=' there were';
   	S4=num2str(extinctions);
   	S5=' extinctions in';
 	S6=num2str(runs);
	S7=' runs for an extinction rate of';
	S8=num2str(extinctions/runs);
	S9=' for runs lasting';
	S10=num2str(final);
	S11=' time steps with an extinction threshold of';
	S12=num2str(thresh);
	Result=strcat(S1,space,S2,S3,space,S4,S5,space,S6,S7,space,S8,S9,space,S10,S11,space,S12)
	if isequal(hidden,1)
		S1='There were'
		S2=num2str(notaboves);
		S3=' apparent extinctions of the aboveground populations for an apparent rate of'
		S4=num2str(notaboves/runs)
		Apparent_Extinctions=strcat(S1,space,S2,S3,space,S4)
	end
end %distcounter for loop
